rem WinHTTP have COM access and is a native component from Windows 2000 with SP3 and above
'cscript.exe bandwidth-test.vbs <datacenter_url>
'e.g. cscript.exe bandwidth-test.vbs "https://performancemanager4.successfactors.com"

'WMIC references: http://technet.microsoft.com/en-us/library/bb742610.aspx
Set vbsArgs = WScript.Arguments
imgURI = "/diagnostic/img/rand-1m.png"
mainURI = "/diagnostic/main"
stringKBPerSecond = " KBytes/sec"
bandwidthTestIteration = 5

Const HTTPREQUEST_PROXYSETTING_DEFAULT = 0
Const HTTPREQUEST_PROXYSETTING_PRECONFIG = 0
Const HTTPREQUEST_PROXYSETTING_DIRECT = 1
Const HTTPREQUEST_PROXYSETTING_PROXY = 2

Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE= &H80000002

Const WinHttpRequestOption_SslErrorIgnoreFlags = 4
Const SslErrorFlag_Ignore_All = 13056

If vbsArgs.Count <> 1 Then
	WScript.StdOut.Write "ERROR: Wrong number of arguments: "&vbsArgs.Count
	WScript.StdOut.Write "<br />"
	WScript.StdOut.Write "Syntax: cscript.exe bandwidth-test.vbs <datacenter_url>"
	
	Set vbsArgs = Nothing
	WScript.Quit
End If	

Set winHttpRequest = CreateObject("WinHttp.WinHttpRequest.5.1")
winHttpRequest.SetTimeouts "600000", "600000", "600000", "9000000"

strComputer = "."
Set objRegistry = GetObject("winmgmts:\\" & strComputer & "\root\default:StdRegProv")

strKeyPath= "SOFTWARE\Policies\Microsoft\Windows\CurrentVersion\Internet Settings"
strValueName = "ProxySettingsPerUser"
objRegistry.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, dwProxySettingsPerUser 

If dwProxySettingsPerUser = 0 Then
	'Group policy overwrites all connection settings for all users
	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Connections" 
	strValueName = "DefaultConnectionSettings"
	rtnDefaultConnectionSettings = objRegistry.GetBinaryValue(HKEY_LOCAL_MACHINE, strKeyPath, strValueName, binValue)
	'Proxy server
	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings"
	strValueName = "ProxyEnable"
	objRegistry.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, dwProxyEnable 
	strValueName = "ProxyServer"
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, strProxyServer
	strValueName = "ProxyOverride"
	objRegistry.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, strProxyOverride
Else
	'Connection settings are set for the currently logged-in user
	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\Connections" 
	strValueName = "DefaultConnectionSettings"
	rtnDefaultConnectionSettings = objRegistry.GetBinaryValue(HKEY_CURRENT_USER, strKeyPath, strValueName, binValue)
	'Proxy server
	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings"
	strValueName = "ProxyEnable"
	objRegistry.GetDWORDValue HKEY_CURRENT_USER, strKeyPath, strValueName, dwProxyEnable 
	strValueName = "ProxyServer"
	objRegistry.GetStringValue HKEY_CURRENT_USER, strKeyPath, strValueName, strProxyServer
	strValueName = "ProxyOverride"
	objRegistry.GetStringValue HKEY_CURRENT_USER, strKeyPath, strValueName, strProxyOverride
End If

'If rtnDefaultConnectionSettings = 0 then
'  'Automatically detect settings
'  If (binValue(8) and 8)=8 Then
'    WScript.StdOut.Write "[DEBUG] Automatically detect settings checked"
'  Else
'    WScript.StdOut.Write "[DEBUG] Automatically detect settings unchecked"
'  End If
'  'Use automatic configuration script
'  If (binValue(4) and 4)=4 Then
'    WScript.StdOut.Write "[DEBUG] Use automatic configuration script checked"
'  Else
'    WScript.StdOut.Write "[DEBUG] Use automatic configuration script unchecked"
'  End If
'  'User a proxy server for your LAN
'  If (binValue(2) and 2)=2 Then
'    WScript.StdOut.Write "[DEBUG] Use a proxy server for your LAN checked"
'  Else
'    WScript.StdOut.Write "[DEBUG] User a proxy server for your LAN unchecked"
'  End If
'Else
'  WScript.StdOut.Write "[ERROR] Error retrieving DefaultConnectionSettings"
'End If
'WScript.StdOut.Write "[DEBUG] dwProxyEnable: "&dwProxyEnable&","
'WScript.StdOut.Write "strProxyServer: "&strProxyServer&","
'WScript.StdOut.Write "strProxyOverride: "&strProxyOverride&"<br/>"

If dwProxyEnable = 0 Then
	'FIXME: Start bandwidth test to specified datacenter URL, using default proxy setting
	dcURL = vbsArgs(0)
	WScript.StdOut.Write "Proxy Enabled: No"&"<br/>"
	winHttpRequest.SetProxy HTTPREQUEST_PROXYSETTING_DEFAULT
Else
	'FIXME: Using specified proxy type, proxy server, by-pass list. 
	'e.g: winHttpRequest.SetProxy(HTTPREQUEST_PROXYSETTING_PROXY, "proxy:8080", ".mydomain.com")
	dcURL = vbsArgs(0)
	WScript.StdOut.Write "Proxy Enabled: Yes"&", "&"Proxy Server: "&strProxyServer&", "&"Proxy by-pass list: "&strProxyOverride&"."&"<br/>"
	winHttpRequest.SetProxy HTTPREQUEST_PROXYSETTING_PROXY, strProxyServer, strProxyOverride
End If

'CAUTION: Ignore all SSL errors
'winHttpRequest.Option(WinHttpRequestOption_SslErrorIgnoreFlags) = SslErrorFlag_Ignore_All
'winHttpRequest.Option(WinHttpRequestOption_EnablePassportAuthentication) = "TRUE"

'Start bandwidth to specified SuccessFactors datacenters
sumSpeed = 0
download_img_link = dcURL&imgURI
http_header_link = dcURL&mainURI
For iter =1 To bandwidthTestIteration
	winHttpRequest.Open "GET", download_img_link, FALSE
	winHttpRequest.SetRequestHeader "Referer", http_header_link
	startTime = timer
	winHttpRequest.Send
	endTime = timer
	
	If endTime > startTime Then 
	   lastTime=endTime-startTime
	ELSE 
	   lastTime=3600*24-startTime+endTime
    End If	   
	
	tempSpeed = FormatNumber(Cstr(1024 / lastTime), 2)
	sumSpeed = sumSpeed + tempSpeed
	WScript.StdOut.Write "Round "&iter&" : "
	'WScript.StdOut.Write " bandwidth test result: "
	WScript.StdOut.Write Cstr(tempSpeed)&stringKBPerSecond
	'WScript.StdOut.Write ", total sumSpeed: "
	'WScript.StdOut.Write sumSpeed
	WScript.StdOut.Write "<br />"
Next
'Calculate and print average bandwidth test result
avgSpeed = FormatNumber(sumSpeed / bandwidthTestIteration, 2)
bandwidthResult = Cstr(avgSpeed)&stringKBPerSecond
WScript.StdOut.Write "<strong>Average: "&bandwidthResult&"</strong>"

Set vbsArgs = Nothing
Set winHttpRequest = Nothing